<!--
SPDX-FileCopyrightText: 2020 Framasoft <https://framasoft.org>
SPDX-FileContributor: Thomas Citharel <thomas.citharel@framasoft.org>

SPDX-License-Identifier: AGPL-3.0-only
-->

<template>
	<div id="login_notes_settings" class="section">
		<h2>{{ t('login_notes', 'Notes on login screen') }}</h2>
		<form class="alignment">
			<h3>{{ t('login_notes', 'Text alignment') }}</h3>
			<NcCheckboxRadioSwitch
				:checked.sync="alignment"
				value="aligned"
				name="login_notes_alignment"
				type="radio">
				{{ t('login_notes', 'Aligned') }}
			</NcCheckboxRadioSwitch>
			<em>{{
				t(
					'login_notes',
					'Note content will be aligned to left (or right with RTL languages).',
				)
			}}</em>
			<NcCheckboxRadioSwitch
				:checked.sync="alignment"
				value="centered"
				name="login_notes_alignment"
				type="radio">
				{{ t('login_notes', 'Centered') }}
			</NcCheckboxRadioSwitch>
			<em>{{ t('login_notes', 'Note content will be centered.') }}</em>

			<h3>{{ t('login_notes', 'Style') }}</h3>
			<NcCheckboxRadioSwitch :checked.sync="githubMarkdown" type="switch">
				{{ t('login_notes', 'Github Markdown Styles') }}
			</NcCheckboxRadioSwitch>
			<em>{{
				t(
					'login_notes',
					'The note will be styled with Github Markdown Style.',
				)
			}}</em>
		</form>
		<h3>{{ t('login_notes', 'Notes list') }}</h3>
		<p class="settings-hint">
			{{ t('login_notes', 'These notes will be shown on the login screen.') }}
		</p>
		<div v-if="notes.length > 0" class="notes">
			<ul>
				<transition-group name="fade" tag="li">
					<ViewNote
						v-for="note in notes"
						:key="note.id"
						:note="note"
						:alignment="alignment"
						:github-markdown="githubMarkdown"
						:available-pages="pages"
						:has-at-least-two2-f-a-providers="hasAtLeastTwo2FAProviders"
						@delete="deleteNote"
						@update="updateNote" />
				</transition-group>
			</ul>
			<NcButton type="primary" @click="showModal">
				{{ t('login_notes', 'Add new note') }}
			</NcButton>
		</div>
		<NcEmptyContent v-else>
			{{ t('login_notes', 'No notes yet') }}
			<template #action>
				<NcButton type="primary" @click="showModal">
					{{ t('login_notes', 'Add new note') }}
				</NcButton>
			</template>
			<template #title>
				{{ t('login_notes', 'No notes yet') }}
			</template>
			<template #icon>
				<NoteEdit />
			</template>
		</NcEmptyContent>
		<NcModal v-if="modal" size="large" @close="closeModal">
			<div class="modal__content">
				<h3>{{ t('login_notes', 'Create note') }}</h3>
				<EditNote
					:available-pages="pages"
					@update="updateNote"
					@create="createNote"
					@cancel="closeModal" />
			</div>
		</NcModal>
	</div>
</template>
<script>
import { loadState } from '@nextcloud/initial-state'
import EditNote from '../components/EditNote.vue'
import ViewNote from '../components/ViewNote.vue'
import axios from '@nextcloud/axios'
import { generateUrl } from '@nextcloud/router'
import { set } from 'vue'
import NcModal from '@nextcloud/vue/dist/Components/NcModal.js'
import NcEmptyContent from '@nextcloud/vue/dist/Components/NcEmptyContent.js'
import NcButton from '@nextcloud/vue/dist/Components/NcButton.js'
import NcCheckboxRadioSwitch from '@nextcloud/vue/dist/Components/NcCheckboxRadioSwitch.js'
import NoteEdit from 'vue-material-design-icons/NoteEdit.vue'

export default {
	name: 'Settings',
	components: {
		ViewNote,
		EditNote,
		NcModal,
		NcEmptyContent,
		NcButton,
		NoteEdit,
		NcCheckboxRadioSwitch,
	},
	data() {
		return {
			notes: loadState('login_notes', 'notes'),
			alignment:
				loadState('login_notes', 'centered') === true
					? 'centered'
					: 'aligned',
			githubMarkdown: loadState('login_notes', 'github_markdown') === true,
			pages: loadState('login_notes', 'pages'),
			newNoteData: { text: '', created_at: 0, pages: { login: true } },
			modal: false,
		}
	},
	computed: {
		hasAtLeastTwo2FAProviders() {
			return (
				[
					this.pages.u2f,
					this.pages.totp,
					this.pages.twofactor_nextcloud_notification,
				].filter((page) => page === true).length >= 2
			)
		},
	},
	watch: {
		async alignment(alignment) {
			await axios.post(generateUrl('/apps/login_notes/settings'), {
				centered: alignment === 'centered',
			})
		},
		async githubMarkdown(githubMarkdown) {
			await axios.post(generateUrl('/apps/login_notes/settings'), {
				github_markdown: githubMarkdown,
			})
		},
	},
	methods: {
		async createNote({ text, pages }) {
			const note = await axios.post(generateUrl('/apps/login_notes/notes'), {
				text,
				pages,
			})
			this.notes.push(note.data)
			this.closeModal()
		},
		async deleteNote(noteId) {
			try {
				await axios.delete(generateUrl(`/apps/login_notes/notes/${noteId}`))
				this.notes = this.notes.filter((note) => note.id !== noteId)
			} catch (e) {
				console.error(e)
			}
		},
		async updateNote({ text, id, pages }) {
			try {
				const { data } = await axios.patch(
					generateUrl(`/apps/login_notes/notes/${id}`),
					{ text, pages },
				)
				set(
					this.notes,
					this.notes.findIndex((note) => note.id === id),
					data,
				)
				this.closeModal()
			} catch (e) {
				console.error(e)
			}
		},
		showModal() {
			this.modal = true
		},
		closeModal() {
			this.modal = false
		},
	},
}
</script>
<style lang="scss" scoped>
#login_notes_settings {
	form {
		textarea {
			width: 600px;
			height: 100px;
		}
	}

	form.alignment {
		margin-bottom: 1rem;
	}

	.empty-content {
		margin-top: 1rem;
		max-width: min(40rem, 100%);
	}
}

// fade transition
.fade {
	&-enter {
		opacity: 0;
	}
	&-enter-to {
		opacity: 1;
	}
	&-leave {
		opacity: 1;
	}
	&-leave-to {
		opacity: 0;
	}
	&-enter-active,
	&-leave-active {
		transition: all 150ms ease-in-out;
	}
}
</style>
<style lang="scss">
.modal__content {
	padding: 1rem;
	textarea {
		width: 100%;
		min-height: 5rem;
	}
}
</style>
